workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
      # Don't run on first init commit of a branch
    - if: $CI_COMMIT_BRANCH && $CI_COMMIT_BEFORE_SHA == "0000000000000000000000000000000000000000"
      when: never
    - if: $CI_COMMIT_BRANCH

default:
  tags:
    - docker
    - lab

stages:
  - test
  - build

include:
  - project: 'digit-c4/dev/python-best-practices'
    file: 'gitlab-ci/test-static-style-check.yml'
    ref: v1.0
  - project: 'digit-c4/dev/python-best-practices'
    file: 'gitlab-ci/test-static-style-force.yml'
    ref: v1.0
  - project: 'digit-c4/dev/python-best-practices'
    file: 'gitlab-ci/build-and-publish-package.yml'
    ref: v2.0

test-static-style-check-job:
  stage: test
  tags:
    - docker
    - lab

test-static-style-force-job:
  stage: test
  variables:
    CI_JOB_TOKEN_WRITE: ${CI_TOKEN_WRITE}
  tags:
    - docker
    - lab

test-unit:
  stage: test
  image: code.europa.eu:4567/digit-c4/dev/python-best-practices/python-poetry:3.11-alpine
  script:
    - poetry install
    - python -m unittest discover tests.unit

test-integration:
  stage: test
  image: code.europa.eu:4567/digit-c4/dev/python-best-practices/python-poetry:3.11-alpine
  script:
    - cd tests/integration/demo
    - poetry install
    - netbox-nms

build-and-publish-package:
  stage: build
  only:
    - main
  tags:
    - docker
    - lab
  variables:
  # path to the project root (default is git root)
  # PROJECT_PATH: "./"

  # perform a dry run "yes" (default) or "no". Mind the quotes as YAML parses yes
  # as boolean, and Gitlab only expects String for variables.
  # IMPORTANT: must be specified for actual publishing as default value is "yes"
    DRY_RUN: "no"
